import math


def fib_ricorsivo(n):
    #definizione ricorsiva della successione di fibonacci
    if(n == 0):
        return 1
    elif (n == 1):
        return 1
    else:
        return fib_ricorsivo(n - 1) + fib_ricorsivo(n - 2)


def fib_binet(n):
    #definizione che usa la formula di binet
    return int(1 / math.sqrt(5) * (((1 + math.sqrt(5)) / 2)**(n+1) - ((1 - math.sqrt(5)) / 2)**(n+1)))


def fib_iterativo(n):
    #definizione iterativa della sucessione di fibonacci

    fib_meno_due = 1
    fib_meno_uno = 1
    risultato = 1

    while n - 1 > 0:
        #deceremento il contatore
        n = n - 1
        #calcolo il nuovo valore
        risultato = fib_meno_due + fib_meno_uno
        #aggiorno i precedenti
        fib_meno_due = fib_meno_uno
        fib_meno_uno = risultato
    return risultato


def test_all_range(n):
    for i in range(0, n):
        print "indice", i
        print "ricorsivo", fib_ricorsivo(i)
        print "iterativo", fib_iterativo(i)
        print "binet", fib_binet(i)
        print "------"
    return 0


def is_it_prime(n):
    #la funzione controlla se il numero e' primo o no
    #posso controllare se e' divisibile per qualche numero fino a sqrt(n)
    flag_primalita = True

    for i in range(2, int(math.sqrt(n)) + 1):
        #quindi effetto un ciclo for per tutti i numeri fino a quello dato
        #effettuo il test
        if((n % i) == 0):
            flag_primalita = False

    if(n <= 3):
        flag_primalita = True

    #una volta uscito dal ciclo for ho testato tutti i valori.
    #controllo la flag
    #e' il valore corretto!
    return flag_primalita

def test_all_prime(n):
    for i in range(0, n):
       risultato = fib_binet(i)
       print "binet:", risultato, is_it_prime(risultato)


#main program

print "il seguente programma calcola la successione di fibonacci"
indice_selezionato = 0

while indice_selezionato != 6:
    print "1) Ricorsione"
    print "2) Iterazione"
    print "3) Binet"
    print "4) Genera una successione"
    print "5) Controllo numero primo"
    print "6) Esci"
    indice_selezionato = input("seleziona:")

    if(indice_selezionato == 1):
        valore = input("inserisci l'indice voluto")
        print fib_ricorsivo(valore)
    elif (indice_selezionato == 2):
        valore = input("inserisci l'indice voluto")
        print fib_iterativo(valore)
    elif (indice_selezionato == 3):
        valore = input("inserisci l'indice voluto")
        print fib_binet(valore)
    elif (indice_selezionato == 4):
        valore = input("inserisci l'indice voluto")
        test_all_range(valore)
    elif (indice_selezionato == 5):
        valore = input("inserisci l'indice voluto")
        test_all_prime(valore)

